// -*- Mode: c++ -*-
// $Id: Draw.cpp,v 1.3 2004/01/31 03:19:19 ps Exp $
// $Source: /cs/research/multires/cvsroot/src/frame/Draw.cpp,v $

// do not edit anything above this line

// include files
#include <stdlib.h>
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include "uistate.h"
#include "Mesh.h"
#include "Vertex.h"
#include "Triangle.h"

#include "Draw.h"

void
DrawHiddenLine( Mesh *m, int& dirty )
{
  static GLuint cache = glGenLists(1);
  
  if( dirty ){
    glNewList( cache, GL_COMPILE_AND_EXECUTE );

    glEnable(GL_POLYGON_OFFSET_FILL);
    glColor3f( 1.f, 1.f, 1.f );
    glDisable( GL_LIGHTING );

    glBegin(GL_TRIANGLES);
    Mesh::TriangleIt ti = m->TriangleBegin(), te = m->TriangleEnd();
    for( ; ti != te; ++ti ){
      const Triangle *t = *ti;
      glVertex3fv( t->a()->p() );
      glVertex3fv( t->b()->p() );
      glVertex3fv( t->c()->p() );
    }
    glEnd();

    glDisable(GL_POLYGON_OFFSET_FILL);
    
    glColor3f(0.f,0.f,0.f);
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

    glBegin(GL_TRIANGLES);
    ti = m->TriangleBegin();
    for( ; ti != te; ++ti ){
      const Triangle *t = *ti;
      glVertex3fv( ( float* )&t->a()->p() );
      glVertex3fv( ( float* )&t->b()->p() );
      glVertex3fv( ( float* )&t->c()->p() );
    }
    glEnd();

    glEnable(GL_LIGHTING);
    glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

    glEndList();

    dirty = 0;
  }else{
    glCallList( cache );
  }
}

void
DrawFlatShaded( Mesh *m, int& dirty )
{
  // do something here
}

void
DrawSmoothShaded( Mesh *m, int& dirty )
{
  // do something here
}

