// -*- Mode: c++ -*-
// $Id: Names.h,v 1.2 2004/01/18 05:46:37 ps Exp $
// $Source: /cs/research/multires/cvsroot/src/frame/Names.h,v $

#ifndef	__NAMES_H__
#define	__NAMES_H__

// unfortunately we need to fix the maximum depth of trees and there are
// other places than just trees who need to know about this...
// if it is compiled with the -64 option we allow trees as deep as 32
// levels otherwise they can be only 16 levels deep
#include <limits.h>

#define __MAXVALENCE 32

enum EdgeName     { EBAD = 0, E1 = 1, E2 = 2,    E3 = 3 };
enum TriangleName {   T0 = 0, T1 = 1, T2 = 2,    T3 = 3 };
enum VertexName   {   V1 = 0, V2 = 1, V3 = 2, VNONE = 3 };


// turn one type of number (rightmost letter) into another kind of number
// (left letter)
inline VertexName   VT( const TriangleName t ) { return VertexName(t-1); }
inline VertexName   VE( const EdgeName e )     { return VertexName(e-1); }
inline EdgeName     EV( const VertexName v )   { return EdgeName(v+1); }
inline TriangleName TV( const VertexName v )   { return TriangleName(v+1); }
inline EdgeName     ET( const TriangleName t ) { return EdgeName(t); }
inline TriangleName TE( const EdgeName e )     { return TriangleName(e); }
inline VertexName   OtherV( const VertexName v1, const VertexName v2 ){
  assert( v1 != v2 ); return VertexName(3 - v1 - v2);
}
inline EdgeName     EVV( const VertexName v1, const VertexName v2 ){
  return EV(OtherV(v1,v2));
}
inline VertexName   HeadV( const EdgeName e ) { return VertexName((e+1)%3); }
inline VertexName   TailV( const EdgeName e ) { return VertexName(e%3); }
inline EdgeName     NextE( const EdgeName e ) { return EdgeName( e%3+1 ); } 
inline EdgeName     PrevE( const EdgeName e ) { return EdgeName((e+1)%3+1); } 
inline VertexName   NextV( const VertexName v ) { return VertexName((v+1)%3); } 
inline VertexName   PrevV( const VertexName v ) { return VertexName((v+2)%3); } 

#endif	/* __NAMES_H__ */
