// -*- Mode: c++ -*-
// $Id: cvec.cpp,v 1.2 2004/01/31 03:19:19 ps Exp $
// $Source: /cs/research/multires/cvsroot/src/frame/cvec.cpp,v $

// do not edit anything above this line

#include <math.h>
#include <assert.h>

#include "cvec.h"

void 
CVec::print(std::ostream& os) const
{
  os << m_v[0] << " " << m_v[1] << " " << m_v[2];
}

std::ostream&
operator<<( std::ostream& os, const CVec& c )
{
  c.print( os );	
  return os;
}

std::istream&
operator>>( std::istream& is, CVec& f )
{
  return is >> f.m_v[0] >> f.m_v[1] >> f.m_v[2];
}


bool
CVec::read( std::istream& is )  {
  return ( is >> m_v[0]) && (is >> m_v[1]) && (is  >> m_v[2]);
}

CVec
CVec::dir( void ) const
{
  float a = l2();
  if( zero( a ) ) return *this;
  else return *this / a;
}

/*
CVec
CVec::perp( void ) const
{
  CVec nrm = *this;
  if( !nrm.normalize() ) return CVec( 1, 0, 0 );

  CVec pnrm;
  // some component must be < 1/(sqrt(3))
  if( fabsf( nrm.m_v[X] ) < 0.6f ) pnrm = cross( CVec( 1, 0, 0 ) );
  else if( fabsf( nrm.m_v[Y] ) < 0.6f ) pnrm = cross( CVec ( 0, 1, 0 ) );
  else if( fabsf( nrm.m_v[Z] ) < 0.6f ) pnrm = cross( CVec ( 0, 0, 1 ) );
  else die();
  
  return pnrm.dir();
}

int
CVec::collinear( const CVec& a, const CVec& b ) const
{
  return zero( ( a - *this ).cross( a - b ).dot() );
}
*/
