// $Id: matrix3x3.h,v 1.1.1.1 2004/01/18 02:59:31 ps Exp $
// $Source: /cs/research/multires/cvsroot/src/frame/matrix3x3.h,v $
//
// Matrix3x3.h
//
// class definition for 3x3 matrices
//
// $Log: matrix3x3.h,v $
// Revision 1.1.1.1  2004/01/18 02:59:31  ps
// Simple viewer framework for ACM106
//
// Revision 1.1.1.1  1998/09/01 19:34:26  jtr
// imported to multires repository

#ifndef	__MATRIXH
#define	__MATRIXH

#include <iostream>

class CVec;
class Quaternion;

class	Matrix3x3{
protected:
  float	mat[9];
public:
  Matrix3x3() {}
  Matrix3x3( const int );
  Matrix3x3( const float, const float, const float,
    const float, const float, const float,
    const float, const float, const float );
  Matrix3x3( const Matrix3x3& );
  Matrix3x3( const Quaternion& );
  Matrix3x3&	operator=( const Matrix3x3& );
  Matrix3x3&  operator=( const Quaternion& );
  
  friend	std::ostream&	operator<<( std::ostream&, const Matrix3x3& );
  
  Matrix3x3	operator-( const Matrix3x3& ) const;
  Matrix3x3	operator+( const Matrix3x3& ) const;
  Matrix3x3	operator/( const float ) const;
  Matrix3x3	operator*( const Matrix3x3& ) const;
  Matrix3x3	operator*( const float ) const;
  Matrix3x3	T() const;
  CVec	operator*( const CVec& ) const;
  CVec	T( const CVec& ) const;
  
  Matrix3x3&	operator-=( const Matrix3x3& );
  Matrix3x3&	operator+=( const Matrix3x3& );
  Matrix3x3&	operator*=( const float );
  Matrix3x3&	operator*=( const Matrix3x3& );
  Matrix3x3&	operator/=( const float );
  
  Matrix3x3	operator-() const;
  const float&	operator()( const int r, const int c )	const
		{ return mat[r * 3 + c]; }
};

#endif	/* MATRIXH */
